﻿' Note: Set the Canvas's Background property to Brushes.White at design time.
Class Window1
    Private start_point As Point
    Private new_circle As Ellipse

    ' Start a circle centered at the starting point.
    Private Sub canCircle_MouseLeftButtonDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles canCircle.MouseLeftButtonDown
        new_circle = New Ellipse()
        new_circle.Width = 0
        new_circle.Height = 0
        new_circle.Stroke = Brushes.Brown

        start_point = e.GetPosition(canCircle)
        Canvas.SetLeft(new_circle, start_point.Y)
        Canvas.SetTop(new_circle, start_point.Y)

        canCircle.Children.Add(new_circle)
    End Sub

    ' Change the circle's size.
    Private Sub canCircle_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles canCircle.MouseMove
        If new_circle IsNot Nothing Then
            ' Get the distance from the start point to this point.
            ' That gives the circle's radius.
            Dim pt As Point = e.GetPosition(canCircle)
            Dim dx As Single = start_point.X - pt.X
            Dim dy As Single = start_point.Y - pt.Y
            Dim r As Single = Math.Sqrt(dx * dx + dy * dy)

            ' Move the new circle.
            new_circle.Width = 2 * r
            new_circle.Height = 2 * r
            Canvas.SetTop(new_circle, start_point.Y - r)
            Canvas.SetLeft(new_circle, start_point.X - r)
        End If
    End Sub

    ' Stop drawing the new circle.
    Private Sub canCircle_MouseLeftButtonUp(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles canCircle.MouseLeftButtonUp
        new_circle = Nothing
    End Sub
End Class
